﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
/*
Ismétlés nélküli kombináció - táblázatkitöltéssel 1
*/
namespace feladat
{
    class Program
    {
        // Konstansok
        const int MAXN = 90;

        static void Beolvasás(out int N, out int K)
        {
            //Feltesszük, hogy helyes az input, ezért nem ellenőrizzük
            Console.Error.WriteLine("Írd be N és K értékét! (N K)");
            string sor = Console.ReadLine();
            string[] adatok = sor.Split(' ');
            N = Convert.ToInt32(adatok[0]);
            K = Convert.ToInt32(adatok[1]);
        }

        static ulong binom(int n, int k)
        {
            ulong[,] b = new ulong[MAXN + 1, MAXN + 1];//64 bites unsigned integer mátrix deklarálása
            //Szélek feltöltése
            for (int i = 0; i <= n; i++)
            {
                b[i,i] = 1;
                b[i,0] = 1;
            }

            for (int i = 1; i <= n; i++)
            {
                for (int j = 1; j <= i - 1; j++)
                {
                    b[i,j] = b[i - 1,j - 1] + b[i - 1,j];
                }
            }
            return b[n, k];
        }

        static void Kiírás(int n, int k, ulong bnk)
        {
            Console.WriteLine("{0} alatt a(z) {1}: {2}", n, k, bnk);
        }

        static void Main(string[] args)
        {
            //A beolvasandó számok
            int N;
            int K;
            Beolvasás(out N, out K);
            ulong bnk = binom(N, K);
            Kiírás(N, K, bnk);
        }
    }
}

